/* 
** include/wiregl_common.h 
** http://graphics.stanford.edu/software/wiregl
**
** Copyright 2000
** The Board of Trustees of The Leland Stanford Junior University.
** All rights reserved.
**
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or
** modify this software, provided that the above copyright notice and
** this permission notice appear in all copies of this software.  No
** part of this software or any derivatives thereof may be used in
** graphics systems for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind,
** express, implied or otherwise, including without limitation, any
** warranty of merchantability or fitness for a particular purpose.
*/

#ifndef WIREGL_COMMON_H
#define WIREGL_COMMON_H

#include "wiregl/include/wiregl_feather.h"

#define WIREGL_REQUEST_PEER_NAME_LENGTH 1024
typedef struct {
    unsigned int  magic;
    unsigned int  max_send;
    int           window_x, window_y;
    unsigned int  window_width, window_height;
	unsigned int  depth_bits;
	unsigned int  stencil_bits;
	WireGLFeatherParam feather;
    unsigned char please_share_memory;
    unsigned char please_use_gm;
	unsigned int  gm_client_id;

	int use_l2;
	int l2_width;
	int l2_height;

	char peer[WIREGL_REQUEST_PEER_NAME_LENGTH];
} WireGLConnectionRequest;

typedef struct {
    unsigned int magic;
    unsigned int max_send;
    unsigned int client_id;
    unsigned int gm_server_id;
} WireGLConnectionResponse;

#define WIREGL_CONNECTION_MAGIC   0x77697265
#define WIREGL_TCPIP_DEFAULT_PORT       7000
#define WIREGL_GM_SERVER_PORT              4
#define WIREGL_GM_CLIENT_PORT              5
#define WIREGL_PIPESERVER_BARRIER         69

#endif /* WIREGL_COMMON_H */
