/* 
** pipe_server/swap.c 
** http://graphics.stanford.edu/software/wiregl
**
** Copyright 2000
** The Board of Trustees of The Leland Stanford Junior University.
** All rights reserved.
**
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or
** modify this software, provided that the above copyright notice and
** this permission notice appear in all copies of this software.  No
** part of this software or any derivatives thereof may be used in
** graphics systems for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind,
** express, implied or otherwise, including without limitation, any
** warranty of merchantability or fitness for a particular purpose.
*/

#include "wiregl/include/wiregl_protocol.h"
#include "wiregl/include/wiregl_pipe.h"

#if defined (IRIX) || defined( IRIX64 ) || defined( Linux)
#include <X11/Xlib.h>

#ifdef __cplusplus
#define C_EXTERN "C"
#else
#define C_EXTERN
#endif

typedef XID GLXDrawable;
extern C_EXTERN void glXSwapBuffers (Display *dpy, GLXDrawable drawable);
#endif

void __decodeSwapBuffers( void )
{
#ifdef WINDOWS
	MSG msg;
#endif
	static int feather_init = 0;

	INCR_DATA_PTR_NO_ARGS( );
#if 0
	if (wiregl_pipe.swap_barrier)
	{
		wireGLBarrierEnter( wiregl_pipe.barrier_conn, 
							WIREGL_PIPESERVER_BARRIER );
	}
#endif
	if ( !feather_init ) 
	{
		wireGLConfigureFeathering ( wiregl_pipe.window_width,
									wiregl_pipe.window_height,
									&wiregl_pipe.feather );
		feather_init = 1;
	}

	wireGLDrawFeatheringStrips( );

#ifdef WINDOWS

	while ( PeekMessage( &msg, wiregl_pipe.hWnd, 0, 0xffffffff, PM_REMOVE ) )
	{
	    TranslateMessage( &msg );    
		DispatchMessage( &msg );
	}

	BringWindowToTop( wiregl_pipe.hWnd );
	SwapBuffers( wiregl_pipe.device_context );

#else

	glXSwapBuffers( wiregl_pipe.dpy, wiregl_pipe.win );

#endif /* !WINDOWS */
}
