/*
** util/parse.c
** Generated by opengl_stub/windows_exports.py
** http://graphics.stanford.edu/software/wiregl
**
** Copyright 2000 
** The Board of Trustees of The Leland Stanford Junior University.
** All rights reserved.
**
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or
** modify this software, provided that the above copyright notice and
** this permission notice appear in all copies of this software.  No
** part of this software or any derivatives thereof may be used in
** graphics systems for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind,
** express, implied or otherwise, including without limitation, any
** warranty of merchantability or fitness for a particular purpose.
**
*/

#include "__utilsource.h"

#include "wiregl/include/wiregl_util.h"

#include <stdio.h>
#include <ctype.h>

#ifndef WINDOWS
#include <errno.h>
#endif

static char *EatWhiteSpace( char *buf )
{
	while (*buf &&isspace( *buf ))
		buf++;
	return buf;
}

UTIL_DECL char *wireGLGetLine( FILE *fp, char *buf )
{
	for ( ; ; )
	{
		char *ass = fgets(buf,1024,fp);
		if (feof(fp) || !ass)
			return NULL;
		ass = EatWhiteSpace( ass );
		if (!ass[0] || ass[0] == '\n' || ass[0] == '#')
			continue;
		break;
	}
	if (buf[strlen(buf) - 1] == '\n')
		buf[strlen(buf) - 1] = '\0';
	return buf;
}

UTIL_DECL void wireGLParseFile( char *filename, WireGLParseStruct *parsers )
{
	char buf[1024];
	FILE *fp = fopen( filename, "r" );
	if ( !fp )
	{
		wireGLSimpleError( "wireGLParseFile( \"%s\" ) : %s", 
						   filename, strerror( errno ) );
	}

	memset( buf, 0, sizeof(buf) );

	while ( wireGLGetLine( fp, buf ) != NULL )
	{
		WireGLParseStruct *ps;
		for (ps = parsers ; ps->str != NULL ; ps++)
		{
			if ( !strncmp( buf, ps->str, strlen( ps->str ) ) )
			{
				char *rest_of_line = &(buf[0]) + strlen(ps->str);
				rest_of_line = EatWhiteSpace( rest_of_line );
				ps->parser( rest_of_line );
				break;
			}
		}
		if ( !ps->str )
		{
			wireGLSimpleError( "wireGLParseFile( \"%s\" ) : parse error: %s",
							   filename, buf );
		}
	}

	fclose( fp );
}
